#***************************************************************************
#*   Copyright (C) 2005 by Alexander Shiyan                                *
#*   shc@users.sourceforge.net                                             *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation; either version 2 of the License, or     *
#*   (at your option) any later version.                                   *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#***************************************************************************

exists($(QTDIR)/lib/libqt*-mt*) {
	CONFIG += thread
}

exists($(QTDIR)/bin/lrelease) {
	CONFIG += langsupport
}

MAINTARGET = qfe

unix {
	STATICLIB_PREF=lib
	STATICLIB_EXT=.a
	OPTIONAL_INCLUDES=
	OPTIONAL_LIBS=
	OPTIONAL_CFLAGS=
	OPTIONAL_CXXFLAGS=
	OPTIONAL_LFLAGS=
}
win32 {
	STATICLIB_PREF=
	STATICLIB_EXT=.lib
	OPTIONAL_INCLUDES=../../../include
	OPTIONAL_LIBS=
	OPTIONAL_CFLAGS=
	OPTIONAL_CXXFLAGS=
	OPTIONAL_LFLAGS=-L../../../lib
}

QMAKE_UIC = $$QMAKE_UIC -tr QObject::tr

unix {
	VERSION = $$system(cd $$PWD; grep "QFE_VERSION" config.h | tr -d [=\"=] | tr -s [:space:] | cut -f 3 -)

	system(env | grep "QFE_PREFIX" > /dev/null):CONFIG += prefix

	!prefix {
		HOME_PATH = $(PREFIX)"/usr/local"
	}
	prefix {
		HOME_PATH = $(PREFIX)$$system(echo $QFE_PREFIX)
	}
}

win32:QMAKE_COPY = xcopy /Y /K /E /Q

!isEmpty(QMAKE_CXX) {
	GCCTEST = $$system($$QMAKE_CXX --version | grep "GCC")
	!isEmpty(GCCTEST) {
		CONFIG += gcc
		GCCVERTEST = $$system($$QMAKE_CXX -dumpversion | grep "^4.")
		!isEmpty(GCCVERTEST):CONFIG += gcc4
	}
}

unix {
	FHUSKY = $$system(find /usr -name $$STATICLIB_PREF"husky"$$STATICLIB_EXT -type f -print -quit)
	FSMAPI = $$system(find /usr -name $$STATICLIB_PREF"smapi"$$STATICLIB_EXT -type f -print -quit)
	FFIDOC = $$system(find /usr -name $$STATICLIB_PREF"fidoconfig"$$STATICLIB_EXT -type f -print -quit)
}
win32 {
	FHUSKY = $$STATICLIB_PREF"husky"$$STATICLIB_EXT
	FSMAPI = $$STATICLIB_PREF"smapi"$$STATICLIB_EXT
	FFIDOC = $$STATICLIB_PREF"fidoconfig"$$STATICLIB_EXT
}
macx {
	error(Not tested with MacOS!)
}

STATICLIBRARYS = $$FHUSKY $$FSMAPI $$FFIDOC
DYNAMICLIBRARYS = -lhusky -lsmapi -lfidoconfig
