#***************************************************************************
#*   Copyright (C) 2005 by Alexander Shiyan                                *
#*   shc@users.sourceforge.net                                             *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation; either version 2 of the License, or     *
#*   (at your option) any later version.                                   *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#***************************************************************************

TEMPLATE = app

CONFIG -= qt warn_on warn_off release debug
CONFIG += qt warn_on debug

!include(../qfe.pri) {
	error(Can't find ../qfe.pri)
}

debug_off {
	CONFIG -= warn_on debug
	CONFIG += warn_off release
}

release:debug:error(Configuration Error!)

!unix:!win32:!macx:error(Unable to determine target operating system!)

TARGET = $$MAINTARGET

!exists(.tmp) {
	system($$QMAKE_MKDIR .tmp)
}

DEPENDPATH += ..

INCLUDEPATH += .. $$OPTIONAL_INCLUDES

QMAKE_CLEAN += *.bak ui/*~
win32:QMAKE_CLEAN += qferc.o

release {
	unix {
		QMAKE_CLEAN += ts/*.qm
		langsupport:QMAKE_POST_LINK = @$(QTDIR)/bin/lrelease -verbose src.pro || true
	}
	!unix {
		QMAKE_CLEAN += ts\*.qm
		langsupport:QMAKE_POST_LINK = @$(QTDIR)/bin/lrelease -verbose src.pro
	}
}

gcc {
	QMAKE_CFLAGS_DEBUG += -O0
	unix:QMAKE_CFLAGS_DEBUG += -Wextra
	QMAKE_CXXFLAGS_DEBUG += -O0
	unix:QMAKE_CXXFLAGS_DEBUG += -Wextra
	QMAKE_CFLAGS_RELEASE += -funroll-all-loops -fomit-frame-pointer -ffast-math -falign-loops=2 -falign-jumps=2 -falign-functions=2 -fPIC
	QMAKE_CXXFLAGS_RELEASE += -funroll-all-loops -fomit-frame-pointer -ffast-math -falign-loops=2 -falign-jumps=2 -falign-functions=2 -fPIC
	QMAKE_LFLAGS_RELEASE += --gc-sections -O

	gcc4 {
		QMAKE_CXXFLAGS_RELEASE += -fvisibility-inlines-hidden -enable-final
	}
}

!exists($(QTDIR)/bin/qembed) {
	!exists(stdconfig.h):error('qembed' not found! Can't continue.)
}

QMAKE_LFLAGS_RELEASE += -s

UI_DIR = .tmp
OBJECTS_DIR = .tmp
MOC_DIR = .tmp

staticlibs {
	!gcc {
		message(Can't link statically, tryes to link dynamic)
		CONFIG -= staticlibs
	}
	staticlibs:!count(STATICLIBRARYS, 3) {
		message(Can't link statically, tryes to link dynamic)
		CONFIG -= staticlibs
	}
	staticlibs {
		LIBS +=  -Wl,--start-group $$STATICLIBRARYS -Wl,--end-group
	}
}
!staticlibs {
	LIBS += $$DYNAMICLIBRARYS
}

LIBS += $$OPTIONAL_LIBS

QMAKE_CFLAGS_DEBUG += $$OPTIONAL_CFLAGS
QMAKE_CFLAGS_RELEASE += $$OPTIONAL_CFLAGS
QMAKE_CXXFLAGS_DEBUG += $$OPTIONAL_CXXFLAGS
QMAKE_CXXFLAGS_RELEASE += $$OPTIONAL_CXXFLAGS
QMAKE_LFLAGS_DEBUG += $$OPTIONAL_LFLAGS
QMAKE_LFLAGS_RELEASE += $$OPTIONAL_LFLAGS

FORMS = ui/mainwindow.ui \
        ui/editwindow.ui \
        ui/options.ui \
        ui/finddlg.ui \
        ui/replacedlg.ui \
        ui/styledlg.ui \
        ui/addressbook.ui \
        ui/nodelistbrowser.ui \
        ui/areaprop.ui \
        ui/areaselect.ui \
        ui/messattr.ui \
        ui/messprop.ui \
        ui/about.ui \
        ui/helpwindow.ui

HEADERS = ui/mainwindow.ui.h \
          ui/editwindow.ui.h \
          ui/options.ui.h \
          ui/finddlg.ui.h \
          ui/replacedlg.ui.h \
          ui/styledlg.ui.h \
          ui/addressbook.ui.h \
          ui/nodelistbrowser.ui.h \
          ui/areaprop.ui.h \
          ui/areaselect.ui.h \
          ui/messattr.ui.h \
          ui/messprop.ui.h \
          ui/about.ui.h \
          ui/helpwindow.ui.h \
          tmessageitem.h

SOURCES = qfe.cpp \
          funchider.cpp \
          tconfig.cpp \
          tarea.cpp \
          tareas.cpp \
          tareaitem.cpp \
          tareaselectitem.cpp \
          tftncodec.cpp \
          tfinditem.cpp \
          tbook.cpp \
          tbookitem.cpp \
          tbookviewitem.cpp \
          tinisettings.cpp \
          tmessage.cpp \
          tmessageitem.cpp \
          ttagitem.cpp \
          taction.cpp \
          tactions.cpp \
          tactionlist.cpp \
          tshortcutitem.cpp \
          tnodes.cpp \
          tnodeitem.cpp \
          tcloseevent.cpp \
          utils.cpp

IMAGES = img/icon_about.xpm \
         img/icon_aboutqt.xpm \
         img/icon_additem.xpm \
         img/icon_addressbook.xpm \
         img/icon_area.xpm \
         img/icon_attach.xpm \
         img/icon_browser.xpm \
         img/icon_cancel.xpm \
         img/icon_color.xpm \
         img/icon_copy.xpm \
         img/icon_cut.xpm \
         img/icon_date.xpm \
         img/icon_decode.xpm \
         img/icon_delete.xpm \
         img/icon_delitem.xpm \
         img/icon_delmail.xpm \
         img/icon_desc.xpm \
         img/icon_down.xpm \
         img/icon_draft.xpm \
         img/icon_edit.xpm \
         img/icon_erase.xpm \
         img/icon_exit.xpm \
         img/icon_find.xpm \
         img/icon_fips.xpm \
         img/icon_flag.xpm \
         img/icon_forward.xpm \
         img/icon_general.xpm \
         img/icon_golded.xpm \
         img/icon_help.xpm \
         img/icon_home.xpm \
         img/icon_index.xpm \
         img/icon_insert.xpm \
         img/icon_keyboard.xpm \
         img/icon_left.xpm \
         img/icon_load.xpm \
         img/icon_mark.xpm \
         img/icon_menu.xpm \
         img/icon_name.xpm \
         img/icon_newmail.xpm \
         img/icon_ok.xpm \
         img/icon_options.xpm \
         img/icon_paste.xpm \
         img/icon_photo.xpm \
         img/icon_plugins.xpm \
         img/icon_print.xpm \
         img/icon_prop.xpm \
         img/icon_redo.xpm \
         img/icon_replace.xpm \
         img/icon_reply.xpm \
         img/icon_replynet.xpm \
         img/icon_rescan.xpm \
         img/icon_right.xpm \
         img/icon_save.xpm \
         img/icon_sent.xpm \
         img/icon_size.xpm \
         img/icon_spell.xpm \
         img/icon_strings.xpm \
         img/icon_style.xpm \
         img/icon_subject.xpm \
         img/icon_template.xpm \
         img/icon_undo.xpm \
         img/icon_unsubscribe.xpm \
         img/icon_up.xpm \
         img/icon_view.xpm \
         img/icon_whatsthis.xpm \
         img/qfe.xpm \
         img/qfe_logo.xpm

unix {
	DEFINES += ENABLE_BINRELOC
	SOURCES += prefix.c
}

DEFAULTCODEC = UTF-8

TRANSLATIONS = ts/qfe_ru.ts

unix {
	exists($(QTDIR)/bin/qembed)
	{
		stdconfig.target = stdconfig.h
		stdconfig.commands = cd ../cfg && $(QTDIR)/bin/qembed `find *.tpl *.lst` > ../src/stdconfig.h
		QMAKE_EXTRA_UNIX_TARGETS += stdconfig

		PRE_TARGETDEPS += stdconfig.h
	}

	target.path = $$HOME_PATH/bin

	langsupport {
		translations.path = $$HOME_PATH/share/$$MAINTARGET/translations
		translations.extra = $(COPY_FILE) ts/*.qm $(INSTALL_ROOT)$$translations.path
		translations.uninstall = -"$(DEL_FILE) $(INSTALL_ROOT)$$translations.path/*.qm"
		tarnslations.depends = target
	}

	readme.path = $$HOME_PATH/share/$$MAINTARGET
	readme.files = ../AUTHORS ../COPYING ../README ../TODO ../FAQ ../ChangeLog ../qfe.lsm

	examples.path = $$HOME_PATH/share/$$MAINTARGET/examples
	examples.files = ../examples/*.sh

	desklink.path = $$HOME_PATH/share/applications
	desklink.files = ../misc/qfe.desktop

	deskicon1.path = $$HOME_PATH/share/icons
	deskicon1.files = img/qfe.xpm

	deskicon2.path = $$HOME_PATH/share/pixmaps
	deskicon2.files = img/qfe.xpm

	INSTALLS += target readme examples desklink deskicon1 deskicon2
	langsupport:INSTALLS += translations
}

win32:RC_FILE = qferc.rc
