/***************************************************************************
 *   Copyright (C) 2005 by Alexander Shiyan                                *
 *   shc@users.sourceforge.net                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _TAREA_H_
#define _TAREA_H_

#include <qptrlist.h>

class TArea;

#include "funchider.h"

#include "tareas.h"
#include "tconfig.h"
#include "tmessage.h"

#include "utils.h"

#define AREA_TYPE_NETMAIL	1
#define AREA_TYPE_DUPE		2
#define AREA_TYPE_BAD		4
#define AREA_TYPE_LOCAL		8
#define AREA_TYPE_ECHOMAIL	16

class TArea : public QPtrList<TMessage>
{
public:
	TArea(TAreas*, s_area, uint);
	~TArea();

	QString Name;
	QString Path;
	QString Desc;
	QString Aka;
	QString Uplink;
	QString UplinkPwd;
	QString UplinkRbt;
	QString Group;
	uint Unread;
	uint Type;
	int MsgbType;
	TAreas *Areas;
	MSGA *Handle;

	bool Open(bool = true);
	void Close();
	uint Index2UID(const uint);
	uint UID2Index(const uint);
	void Rescan();
	uint Marked();
	TMessage *Add(uint);
	TMessage *New();
	uint GetLastRead();
	void SetLastRead(uint);
	void KillMessage(uint);
	void MarkAllAsRead();
private:
	uint dummyLastRead;
};

#endif // _TAREA_H_
