/***************************************************************************
 *   Copyright (C) 2005 by Alexander Shiyan                                *
 *   shc@users.sourceforge.net                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "tareas.h"

TAreas::TAreas()
{
	setAutoDelete(true);
}

TAreas::~TAreas()
{
	Close();
}

uint TAreas::Find(QString _name)
{
	for (uint i = 0; i < count(); i++)
		if (strcompare(at(i)->Name, _name))
			return i + 1;
	return 0;
}

TArea *TAreas::Add(s_area Area, uint Type)
{
	TArea *It = new TArea(this, Area, Type);
	append(It);
	return It;
}

bool TAreas::Open(TArea *_Area)
{
	for (uint i = 0; i < count(); i++)
		if (_Area == at(i))
			return _Area->Open();
	return false;
}

void TAreas::Close()
{
	for (uint i = 0; i < count(); i++)
		at(i)->Close();
}

void TAreas::Rescan()
{
	for (uint i = 0; i < count(); i++)
		at(i)->Rescan();
}
