/***************************************************************************
 *   Copyright (C) 2005 by Alexander Shiyan                                *
 *   shc@users.sourceforge.net                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _TFTNCODEC_H_
#define _TFTNCODEC_H_

#include <qfile.h>
#include <qstring.h>
#include <qptrlist.h>

#include "funchider.h"

#include "utils.h"

#include "tmessage.h"

#define ERROR_ENCODE_FILEOPEN		-1
#define ERROR_ENCODE_MAXSECTIONS	-2

#define MAX_ENCODE_UUELENGTH		45
#define MAX_ENCODE_B64LENGTH		72

// This functions are untested & may be buggy
QString EncodeQuotedPrintable(QString, QString = "");
QString DecodeQuotedPrintable(QString, QString = "");

class TFTNCoDecPart
{
public:
	TFTNCoDecPart(QByteArray*, uint, uint, QString, QString, uint, uint);
	TFTNCoDecPart(uint, uint, QString, QString, uint, uint);
	~TFTNCoDecPart();

	QByteArray *Array;
	QString PartString;
	uint Section;
	uint AllCount;
	uint Permissions;
	QString FileName;
	QString ID;
	uint Type;
};

class TFTNCoDec: public QPtrList<TFTNCoDecPart>
{
public:
	TFTNCoDec();

	void DecodeMessage(TMessage*);
	int EncodeFile(QString, uint, uint);
	bool MakeFile(QByteArray*, QString*);
};

#endif // _TFTNCODEC_H_
