/***************************************************************************
 *   Copyright (C) 2005 by Alexander Shiyan                                *
 *   shc@users.sourceforge.net                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _TMESSAGE_H_
#define _TMESSAGE_H_

#include "tfidoconfig.h"

class TMessage;

#include "tarea.h"
#include "tmessageitem.h"

class TMessage
{
public:
	TMessage(TArea*, const uint, const bool = false);
	~TMessage();

	XMSG MsgInfo;
	int TextLen;
	uint Index;
	int CtrlLen;
	byte *TextBuffer;
	byte *CtrlBuffer;
	TArea *Area;
	TMessageItem *MessageItem;

	void Close();
	uint UID();
	bool ReadMessage();
	bool WriteMessage(const bool = false);
	bool ToggleFlag(const dword, const bool);
	void MarkAsRead();
	bool isFlagsSet(const dword);
private:
	bool isReaded;
	MSGH *Handle;

	bool Open(const uint);
};

#endif // _TMESSAGE_H_
