/***************************************************************************
 *   Copyright (C) 2005 by Alexander Shiyan                                *
 *   shc@users.sourceforge.net                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _TNODES_H_
#define _TNODES_H_

#include <qfile.h>
#include <qstring.h>
#include <qlistview.h>
#include <qptrlist.h>
#include <qapplication.h>

#include "funchider.h"

class TNode;

#include "tconfig.h"
#include "tnodeitem.h"
#include "tfidoconfig.h"

#define NDL_MAX_LINE_LENGTH	128

#define RECORD_TYPE_ZONE	0

#define RECORD_TYPE_REGION	1
#define RECORD_TYPE_HOST	2

#define RECORD_TYPE_HUB		3
#define RECORD_TYPE_PVT		4
#define RECORD_TYPE_HOLD	5
#define RECORD_TYPE_DOWN	6
#define RECORD_TYPE_NODE	7

#define RECORD_TYPE_POINT	8

class TNode
{
public:
	TNode(word*, word*, word*, word*, uint, char*);

	NETADDR addr;
	uint type;
	QString line;
};

class TNodes : public QPtrList<TNode>
{
public:
	TNodes();

	QListView *ListView;

	void AssignListView(QListView*);
	uint TestCount();
	uint Compile();
private:
	int Find(word, word, word, word = 0);
	void AddNode(word*, word*, word*, word*, uint, char*);
	bool ParseString(char*, word*, char*);
	void ProcessLine(int, char*, word*, word*, word*);
	bool ProcessList(char*, nodelist*);
protected:
	virtual int compareItems(QPtrCollection::Item, QPtrCollection::Item);
};

#endif // _TNODES_H_
