/***************************************************************************
 *   Copyright (C) 2005 by Alexander Shiyan                                *
 *   shc@users.sourceforge.net                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

const int DefSplitterHWidth[] = {247, 536};
const int DefSplitterVWidth[] = {207, 304};

extern TAreas *Areas;
extern TConfig *Config;

const QColor DefGoldedColors[] = {
	QColor(255, 255, 255),
	QColor(0, 0, 255),
	QColor(0, 255, 255),
	QColor(255, 255, 0),
	QColor(255, 0, 0),
	QColor(0, 170, 0),
	QColor(0, 255, 0),
	QColor(128, 128, 128),
	QColor(77, 142, 148),
	QColor(85, 85, 255),
	QColor(85, 255, 255),
	QColor(255, 170, 0),
	QColor(255, 85, 0),
	QColor(85, 170, 0),
	QColor(85, 255, 0)
};

void TMainWindow::init()
{
	int i;

	FirstTimeInit = false;

	setIcon(QIconSet(*Config->FindPixmap("qfe.xpm"), QIconSet::Large).pixmap(QIconSet::Small, QIconSet::Normal));

	MainActions = new TActions();

	MainActions->AddAction(FileMenu, MainMenuBar->text(1), OpenAction, "icon_load.xpm", QObject::tr("Open Message File for View"), QObject::tr("Supported Formats is MSG, PKT"), "Ctrl+O", true);
	MainActions->AddAction(FileMenu, MainMenuBar->text(1), SaveAction, "icon_save.xpm", QObject::tr("Save Current Message to File"), QObject::tr("Supported Formats is TXT, HTML"), "Ctrl+S");
	MainActions->AddAction(FileMenu, MainMenuBar->text(1), PrintAction, "icon_print.xpm", QObject::tr("Print Current Message"), QObject::tr("You must print entrie message, or only selected region"), "Ctrl+P");
	MainActions->AddAction(FileMenu, MainMenuBar->text(1), OptionsAction, "icon_options.xpm", QObject::tr("Edit Program Options"), QObject::tr("In \"Options\" dialog You must define fonts, colors and other settings for best view"));
	MainActions->AddAction(FileMenu, MainMenuBar->text(1), ExitAction, "icon_exit.xpm", QObject::tr("Quit Program"), QString::null, "Ctrl+Q");

	MainActions->AddAction(MessageMenu, MainMenuBar->text(2), NewAction, "icon_newmail.xpm", QObject::tr("Create New Message in Current Area"), QString::null, "Ins");
	MainActions->AddAction(MessageMenu, MainMenuBar->text(2), EditAction, "icon_edit.xpm", QObject::tr("Edit Current Message"));
	MainActions->AddAction(MessageMenu, MainMenuBar->text(2), ReplyAction, "icon_reply.xpm", QObject::tr("Create Reply to Current Message"));
	MainActions->AddAction(MessageMenu, MainMenuBar->text(2), ReplyNetmailAction, "icon_replynet.xpm", QObject::tr("Create Reply to Current Message in NetMail Area"));
	MainActions->AddAction(MessageMenu, MainMenuBar->text(2), ForwardAction, "icon_forward.xpm", QObject::tr("Forward Current Message to Another Area"));
	MainActions->AddAction(MessageMenu, MainMenuBar->text(2), DeleteAction, "icon_delmail.xpm", QObject::tr("Delete Current Message from MessageBase"), QString::null, "Del");
	MainActions->AddAction(MessageMenu, MainMenuBar->text(2), PreviousMessAction, "icon_left.xpm", QObject::tr("Go to Previous Message in Current Area"), QString::null, "Up");
	MainActions->AddAction(MessageMenu, MainMenuBar->text(2), NextMessAction, "icon_right.xpm", QObject::tr("Go to Next Message in Current Area"), QString::null, "Down");
	MainActions->AddAction(MessageMenu, MainMenuBar->text(2), MarkMessAction, "icon_mark.xpm", QObject::tr("Mark/Unmark Current Message"), QString::null, "Space");
	MainActions->AddAction(MessageMenu, MainMenuBar->text(2), MessagePropAction, "icon_prop.xpm", QObject::tr("View Message Properties"), QString::null, QString::null, true);

	MainActions->AddAction(AreaMenu, MainMenuBar->text(3), RescanAction, "icon_rescan.xpm", QObject::tr("Rescan Area"), QString::null, QString::null, true);
	MainActions->AddAction(AreaMenu, MainMenuBar->text(3), PreviousAreaAction, "icon_up.xpm", QObject::tr("Go to Previous Area"), QString::null, "Left");
	MainActions->AddAction(AreaMenu, MainMenuBar->text(3), NextAreaAction, "icon_down.xpm", QObject::tr("Go to Next Area"), QString::null, "Right");
	MainActions->AddAction(AreaMenu, MainMenuBar->text(3), MarkAllAsReadAction, "icon_flag.xpm", QObject::tr("Mark All Messages in Current Area As Read"));
	MainActions->AddAction(AreaMenu, MainMenuBar->text(3), UnsubscribeAction, "icon_unsubscribe.xpm", QObject::tr("Unsubscribe from Current Area"), QString::null, QString::null);
	MainActions->AddAction(AreaMenu, MainMenuBar->text(3), AreaPropAction, "icon_prop.xpm", QObject::tr("View Area Properties"));

	MainActions->AddAction(ViewMenu, MainMenuBar->text(4), ViewToolBarAction, QString::null, QObject::tr("Show/Hide ToolBar"));
	MainActions->AddAction(ViewMenu, MainMenuBar->text(4), ViewStatusBarAction, QString::null, QObject::tr("Show/Hide StatusBar"));
	MainActions->AddAction(ViewMenu, MainMenuBar->text(4), ViewKludgesAction, QString::null, QObject::tr("Show/Hide Kludge lines from Message"));
	MainActions->AddAction(ViewMenu, MainMenuBar->text(4), ViewHighlightAction, QString::null, QObject::tr("Show/Hide Color Message Highlighting"));
	MainActions->AddAction(ViewMenu, MainMenuBar->text(4), WordWrapAction, QString::null, QObject::tr("Wrap Text On/Off in View Window"));

	MainActions->AddAction(ToolsMenu, MainMenuBar->text(5), RescanAllAction, "icon_rescan.xpm", QObject::tr("Rescan All Areas"));
	MainActions->AddAction(ToolsMenu, MainMenuBar->text(5), FindAction, "icon_find.xpm", QObject::tr("Search for Messages"), QObject::tr("Searching allowed in One Area, or in All Areas"), "Ctrl+F");
	MainActions->AddAction(ToolsMenu, MainMenuBar->text(5), DecodeAction, "icon_decode.xpm", QObject::tr("Decode UUE from Marked Messages"), QObject::tr("Supported Formats is UUE, Base64"));
	MainActions->AddAction(ToolsMenu, MainMenuBar->text(5), NodelistBrowserAction, "icon_browser.xpm", QObject::tr("Run Extended Nodelist Browser"), QString::null, QString::null, true);
	MainActions->AddAction(ToolsMenu, MainMenuBar->text(5), AddressBookAction, "icon_addressbook.xpm", QObject::tr("View AddessBook"), QString::null, "Ctrl+A");
	MainActions->AddAction(ToolsMenu, MainMenuBar->text(5), ExtensionsAction, "icon_plugins.xpm", QObject::tr("Execute Program Extensions"), QString::null, QString::null, true);

	MainActions->AddAction(HelpMenu, MainMenuBar->text(6), HelpAction, "icon_help.xpm", QObject::tr("View Program Help"), QString::null, "F1", true);
	MainActions->AddAction(HelpMenu, MainMenuBar->text(6), AboutAction, "icon_about.xpm", QObject::tr("Some Information About this Program"));
	MainActions->AddAction(HelpMenu, MainMenuBar->text(6), AboutQtAction, "icon_aboutqt.xpm", QObject::tr("Some Information About Qt-Library, used in this Program"));
	MainActions->AddAction(HelpMenu, MainMenuBar->text(6), WhatsThisAction, "icon_whatsthis.xpm", QObject::tr("Enter in \"What is This?\"-Mode"), QString::null, "Shift+F1");

	AreaListPopup = new QPopupMenu(AreaList);
	RescanAction->addTo(AreaListPopup);
	AreaListPopup->insertSeparator();
	MarkAllAsReadAction->addTo(AreaListPopup);
	AreaListPopup->insertSeparator();
	UnsubscribeAction->addTo(AreaListPopup);
	AreaListPopup->insertSeparator();
	AreaPropAction->addTo(AreaListPopup);

	MessListPopup = new QPopupMenu(MessageList);
	EditAction->addTo(MessListPopup);
	MessListPopup->insertSeparator();
	ReplyAction->addTo(MessListPopup);
	ReplyNetmailAction->addTo(MessListPopup);
	ForwardAction->addTo(MessListPopup);
	DeleteAction->addTo(MessListPopup);
	MessListPopup->insertSeparator();
	MarkMessAction->addTo(MessListPopup);
	MessListPopup->insertSeparator();
	MessagePropAction->addTo(MessListPopup);

	WhatsThisAction->addTo(MainToolBar);
	MainToolBar->setCloseMode(QDockWindow::Undocked);

	Config->GetToolBar(this, MainToolBar);
	ViewToolBarAction->setOn(MainToolBar->isShown());

	ViewStatusBarAction->setOn(Config->GetBool(QString::null, CONFIG_VIEWSTATUSBAR, true));
	ActionViewStatusBar();

	ViewKludgesAction->setOn(Config->GetBool(QString::null, CONFIG_VIEWKLUDGES, false));
	ViewHighlightAction->setOn(Config->GetBool(QString::null, CONFIG_VIEWHIGHLIGHT, true));
	WordWrapAction->setOn(Config->GetBool(QString::null, CONFIG_VIEWWORDWRAP, true));
	ActionWordWrap();

	Config->GetPos(this, 0, 0);
	Config->GetSize(this, 800, 600);

	Config->GetSplitter(QString::null, HorSplitter, &DefSplitterHWidth[0]);
	Config->GetSplitter(QString::null, VerSplitter, &DefSplitterVWidth[0]);

	setWindowState(Config->GetInt(QString::null, CONFIG_WINDOWSTATE, Qt::WindowMaximized) & ~Qt::WindowActive);

	AreaList->setColumnText(0, QIconSet(*Config->FindPixmap("icon_index.xpm")), "N");
	AreaList->setColumnText(1, QIconSet(*Config->FindPixmap("icon_area.xpm")), QObject::tr("Area"));
	AreaList->setColumnText(2, QIconSet(*Config->FindPixmap("icon_desc.xpm")), QObject::tr("Description"));
	Config->GetList(QString::null, AreaList);

	MessageList->setColumnText(0, QIconSet(*Config->FindPixmap("icon_index.xpm")), "N");
	MessageList->setColumnText(1, QIconSet(*Config->FindPixmap("icon_mark.xpm")), "");
	MessageList->setColumnText(2, QIconSet(*Config->FindPixmap("icon_name.xpm")), QObject::tr("From"));
	MessageList->setColumnText(3, QIconSet(*Config->FindPixmap("icon_name.xpm")), QObject::tr("To"));
	MessageList->setColumnText(4, QIconSet(*Config->FindPixmap("icon_subject.xpm")), QObject::tr("Subject"));
	MessageList->setColumnText(5, QIconSet(*Config->FindPixmap("icon_size.xpm")), QObject::tr("Size"));
	MessageList->setColumnText(6, QIconSet(*Config->FindPixmap("icon_date.xpm")), QObject::tr("Date"));
	Config->GetList(QString::null, MessageList);

	KludgeItem = new QStyleSheetItem(TextEdit->styleSheet(), "ktag");
	OriginItem = new QStyleSheetItem(TextEdit->styleSheet(), "otag");
	TaglineItem = new QStyleSheetItem(TextEdit->styleSheet(), "ltag");
	TearlineItem = new QStyleSheetItem(TextEdit->styleSheet(), "rtag");
	QuoteItem = new QStyleSheetItem(TextEdit->styleSheet(), "qtag");
	UrlItem = new QStyleSheetItem(TextEdit->styleSheet(), "utag");

	for (i = 0; i < 15; i++)
		GoldedColorTextItem[i] = new QStyleSheetItem(TextEdit->styleSheet(), QString("gtag%1").arg(i + 1));
	for (i = 0; i < 3; i++)
		FipsColorTextItem[i] = new QStyleSheetItem(TextEdit->styleSheet(), QString("ftag%1").arg(i + 1));
	LastAreaName = Config->GetStr(QString::null, CONFIG_LASTAREA, "NETMAIL");
	LoadSettings();
	Areas = new TAreas();
	ActiveEditCnt = 0;

	Current = NULL;

	HelpWindow = NULL;

	ProgressBar = new QProgressBar(statusBar());
	ProgressBar->hide();
	statusBar()->addWidget(ProgressBar, 0, true);
}

void TMainWindow::destroy()
{
	if (HelpWindow != NULL)
		delete HelpWindow;

	delete Areas;
	delete MainActions;

	statusBar()->removeWidget(ProgressBar);
	delete ProgressBar;
}

void TMainWindow::LoadSettings()
{
	int i;

	Config->ChangeTextCodec(Config->GetStr(CONFIG_SECTION_FIDO, CONFIG_FIDOCODEPAGE, "IBM 866"));

	TextEdit->setFont(QFont(Config->GetStr(QString::null, CONFIG_FONTNAME, DEFAULT_VIEW_FONT), Config->GetInt(QString::null, CONFIG_FONTSIZE, DEFAULT_VIEW_FONTSIZE)));
	TextEdit->setPaletteBackgroundColor(QColor(Config->GetInt(QString::null, CONFIG_FONTBACK, QColor(0, 0, 0).rgb())));
	QColor FColor = QColor(Config->GetInt(QString::null, CONFIG_FONTCOLOR, QColor(220, 220, 220).rgb()));
	TextEdit->setPaletteForegroundColor(FColor);

	Config->GetStyleSheetItem(QString::null, KludgeItem, QColor(111, 111, 111).rgb());
	Config->GetStyleSheetItem(QString::null, OriginItem, Qt::red);
	Config->GetStyleSheetItem(QString::null, TaglineItem, Qt::green);
	Config->GetStyleSheetItem(QString::null, TearlineItem, Qt::blue);
	Config->GetStyleSheetItem(QString::null, QuoteItem, QColor(175, 175, 175).rgb());
	Config->GetStyleSheetItem(QString::null, UrlItem, Qt::blue, STYLE_UNDERLINE);
	for (i = 0; i < 15; i++)
		Config->GetStyleSheetItem(QString::null, GoldedColorTextItem[i], DefGoldedColors[i]);
	Config->GetStyleSheetItem(QString::null, FipsColorTextItem[0], QColor(0, 255, 0), STYLE_BOLD);
	Config->GetStyleSheetItem(QString::null, FipsColorTextItem[1], FColor, STYLE_UNDERLINE);
	Config->GetStyleSheetItem(QString::null, FipsColorTextItem[2], FColor, STYLE_ITALIC);
}

void TMainWindow::showEvent(QShowEvent *)
{
	if (FirstTimeInit)
		return;

	qApp->flush();
	QTimer::singleShot(200, this, SLOT(ActionRescanAll()));
}

void TMainWindow::closeEvent(QCloseEvent *e)
{
	if (ActiveEditCnt)
	{
		informationmessage(this, QObject::tr("You have one or more opened Editors. Quit canceled."));
		return;
	}

	if (HelpWindow != NULL)
		HelpWindow->hide();

	Config->SetStr(QString::null, CONFIG_LASTAREA, LastAreaName);
	Config->SetToolBar(this, MainToolBar);
	Config->SetBool(QString::null, CONFIG_VIEWSTATUSBAR, statusBar()->isShown());
	Config->SetBool(QString::null, CONFIG_VIEWKLUDGES, ViewKludgesAction->isOn());
	Config->SetBool(QString::null, CONFIG_VIEWHIGHLIGHT, ViewHighlightAction->isOn());
	Config->SetBool(QString::null, CONFIG_VIEWWORDWRAP, WordWrapAction->isOn());

	Config->SetList(QString::null, AreaList);
	Config->SetList(QString::null, MessageList);

	Config->SetInt(QString::null, CONFIG_WINDOWSTATE, windowState());
	hide();
	setWindowState(Qt::WindowNoState);

	Config->SetSplitter(QString::null, HorSplitter);
	Config->SetSplitter(QString::null, VerSplitter);

	Config->SetPos(this);
	Config->SetSize(this);
	e->accept();
}

void TMainWindow::customEvent(QCustomEvent *e)
{
	bool DoRescan;
	if (e->type() == TCloseEventID)
	{
		TEditWindow *EditWnd = (TEditWindow*)((TCloseEvent*)e)->GetWindow();
		DoRescan = ((TCloseEvent*)e)->GetResult();
		while (EditWnd->isShown()) {};
		ActiveEditCnt--;
		OptionsAction->setEnabled(ActiveEditCnt == 0);
		delete EditWnd;
		//TODO: Rescan only modified areas
		if (DoRescan)
			ActionRescanAll();
	}
}

void TMainWindow::ActionClose()
{
	WidgetCloseFunc(this);
}

void TMainWindow::AreaListContextMenuRequested(QListViewItem *Item, const QPoint &Pt, int)
{
	if (Item)
		AreaListPopup->popup(Pt);
}

void TMainWindow::MessageListContextMenuRequested(QListViewItem *Item, const QPoint &Pt, int)
{
	if (Item)
		MessListPopup->popup(Pt);
}

void TMainWindow::ActionOpen()
{
	if (Config->IsDevelopMode())
	{
		QFileDialog* fd = new QFileDialog(this);
		fd->setDir(Config->GetStr(QString::null, CONFIG_LASTOPENSAVE, QString::null));
		fd->setFilter(QObject::tr("All Files (*)"));
		fd->setCaption(QObject::tr("Select file..."));
		fd->setIcon(*Config->FindPixmap("icon_load.xpm"));
		fd->setMode(QFileDialog::ExistingFile);
		fd->setInfoPreviewEnabled(true);
		/*if (fd->exec() == QDialog::Accepted)
		{
			Config->SetStr(QString::null, CONFIG_LASTOPENSAVE, fd->dir()->absPath());
			//
		}*/
		delete fd;
	} else
		qDebug("TMainWindow::ActionOpen() Not implemented yet...");
}

void TMainWindow::LoadTemplate(QString Name, QString Area, QString *Buff)
{
	QString tmp = Config->ConfigPath + Name + "." + Area;

	*Buff = QString::null;

	if (!testexists(tmp))
	{
		tmp = Config->ConfigPath + Name;
		if (!testexists(tmp))
			return;
	}

	QFile tpl(tmp);
	if (FileOpenFunc(&tpl, IO_ReadOnly))
	{
		QTextStream stream(&tpl);
		while (!stream.atEnd())
			Buff->append(stream.readLine().append("\n"));
		FileCloseFunc(&tpl);
	}
}

void TMainWindow::ActionSave()
{
	QFileDialog* fd = new QFileDialog(this);
	fd->setDir(Config->GetStr(QString::null, CONFIG_LASTOPENSAVE, QString::null));
	fd->setFilter(QObject::tr("Text Files (*.txt)"));
	fd->addFilter(QObject::tr("HTML Files (*.htm *.html)"));
	fd->setSelectedFilter(0);
	fd->setCaption(QObject::tr("Select file..."));
	fd->setIcon(*Config->FindPixmap("icon_save.xpm"));
	fd->setMode(QFileDialog::AnyFile);
	fd->setInfoPreviewEnabled(true);
	if (fd->exec() == QDialog::Accepted)
	{
		Config->SetStr(QString::null, CONFIG_LASTOPENSAVE, fd->dir()->absPath());

		TMessage *Message = ((TMessageItem*)MessageList->selectedItem())->Message;
		char *TextBuffer = new char[Message->TextLen + 1];

		qstrncpy(TextBuffer, (char*)Message->TextBuffer, Message->TextLen);
		TextBuffer[Message->TextLen] = '\0';
		fix_crlf(TextBuffer);

		QString Lines, Buffer = Config->toUTF(TextBuffer);
		QStringList BufferList = QStringList::split("\n", Buffer, true);

		int findex = -1, i = BufferList.count() - 1;
		while (i >= 0)
			if (BufferList[i].startsWith("SEEN-BY: ") || BufferList[i].startsWith("\001PATH: ") || BufferList[i].startsWith("\001Via "))
				BufferList.remove(BufferList[i]);
			else
				if (!BufferList[i].isEmpty())
					break;
				else
					i--;

		QString RealName = fd->selectedFile();

		if (fd->selectedFilter().find("txt") > 0)
		{
			findex = 0;
			if (!RealName.endsWith(".txt", false))
				RealName = RealName.append(".txt");
			LoadTemplate(TPL_SAVETXT_TPL, Message->Area->Name, &Lines);
		} else if (fd->selectedFilter().find("html") > 0)
		{
			for (i = 0; i < (int)BufferList.count(); i++)
				BufferList[i] = convert2qhtm(convert2qhtm_ext(BufferList[i]));

			if (!RealName.endsWith(".htm", false) && !RealName.endsWith(".html", false))
				RealName = RealName.append(".htm");
			findex = 1;
			LoadTemplate(TPL_SAVEHTM_TPL, Message->Area->Name, &Lines);
		} else
			errormessage(this, QObject::tr("Unknown format."));

		switch (findex)
		{
			case 0:
			case 1:
				{
					ExpandMacros(Message->Area, Message, &Lines, Message->Area->Name);
					ExpandMacros2(this, &Lines);
					Lines.replace("@text@", BufferList.join(((findex == 0) ? "\n" : "<br>\n")));

					QFile SavedFile(RealName);
					if (SavedFile.exists())
						if (!questionmessage(this, QObject::tr("File already exists. Overwrite?")))
							break;

					if (FileOpenFunc(&SavedFile, IO_WriteOnly | IO_Truncate))
					{
						QTextStream Stream(&SavedFile);
						Stream.setEncoding(QTextStream::UnicodeUTF8);
						Stream << Lines;
						FileCloseFunc(&SavedFile);
						statusBar()->message(QObject::tr("File saved"), 1000);
					} else
						errormessage(this, QObject::tr("Unable to save file."));
				}
				break;
			default:
				break;
		}

		delete TextBuffer;
	}
	delete fd;
}

void TMainWindow::RunEditor(TArea *Area, TMessage *Message, uint Operation, void *tmp)
{
	TEditWindow *EditWnd = new TEditWindow(this);

	if (EditWnd->SetUp(Area, Message, Operation, tmp))
	{
		EditWnd->show();
		ActiveEditCnt++;
		OptionsAction->setEnabled(false);
	} else
		delete EditWnd;
}

void TMainWindow::ActionNew()
{
	RunEditor(((TAreaItem*)AreaList->selectedItem())->Area, NULL, MSG_OPERATION_NEW, NULL);
}

void TMainWindow::ActionEdit()
{
	RunEditor(((TAreaItem*)AreaList->selectedItem())->Area, ((TMessageItem*)MessageList->selectedItem())->Message, MSG_OPERATION_EDIT, NULL);
}

void TMainWindow::ActionReply()
{
	RunEditor(((TAreaItem*)AreaList->selectedItem())->Area, ((TMessageItem*)MessageList->selectedItem())->Message, MSG_OPERATION_REPLY, NULL);
}

void TMainWindow::ActionReplyNetmail()
{
	TAreaSelect *SelectWnd = new TAreaSelect(this);
	for (uint i = 0; i < Areas->count(); i++)
	{
		TArea *Area = Areas->at(i);
		if (Area->Type == AREA_TYPE_NETMAIL)
			SelectWnd->AddArea((void*)Area);
	}
	if (SelectWnd->AreasCnt > 1)
	{
		if (SelectWnd->exec() == QDialog::Accepted)
			RunEditor(((TAreaSelectItem*)SelectWnd->SelectAreaList->selectedItem())->Area, ((TMessageItem*)MessageList->selectedItem())->Message, MSG_OPERATION_REPLYNET, NULL);
	} else if (SelectWnd->AreasCnt == 1)
		RunEditor(((TAreaSelectItem*)SelectWnd->SelectAreaList->firstChild())->Area, ((TMessageItem*)MessageList->selectedItem())->Message, MSG_OPERATION_REPLYNET, NULL);
	delete SelectWnd;
}

void TMainWindow::ActionForward()
{
	TAreaSelect *SelectWnd = new TAreaSelect(this);
	for (uint i = 0; i < Areas->count(); i++)
	{
		TArea *Area = Areas->at(i);
		if ((Area->Type == AREA_TYPE_NETMAIL) || (Area->Type == AREA_TYPE_ECHOMAIL))
			if ((Area->Type == AREA_TYPE_NETMAIL) || (Area != ((TAreaItem*)AreaList->selectedItem())->Area))
				SelectWnd->AddArea((void*)Area);
	}
	if (SelectWnd->AreasCnt)
		if (SelectWnd->exec() == QDialog::Accepted)
			RunEditor(((TAreaSelectItem*)SelectWnd->SelectAreaList->selectedItem())->Area, ((TMessageItem*)MessageList->selectedItem())->Message, MSG_OPERATION_FORWARD, NULL);
	delete SelectWnd;
}

void TMainWindow::ActionDelete()
{
	if (questionmessage(this, QObject::tr("Do You really want delete current message?")))
	{
		((TAreaItem*)AreaList->selectedItem())->Area->KillMessage(((TMessageItem*)MessageList->selectedItem())->Message->Index);
		Current = NULL;
		AreaChanged(AreaList->selectedItem());
		AreaList->repaintItem(AreaList->selectedItem());
	}
}

void TMainWindow::ActionFind()
{
	TFind *FindWnd = new TFind(this);

	FindWnd->exec();

	delete FindWnd;
}

void TMainWindow::ActionPreviousMess()
{
	MessageList->setSelected(MessageList->selectedItem()->itemAbove(), true);
}

void TMainWindow::ActionNextMess()
{
	MessageList->setSelected(MessageList->selectedItem()->itemBelow(), true);
}

void TMainWindow::ActionMarkMessage()
{
	((TMessageItem*)MessageList->selectedItem())->ToggleMarked();
	if (NextMessAction->isEnabled())
		ActionNextMess();
	DecodeAction->setEnabled(((TAreaItem*)AreaList->selectedItem())->Area->Marked() > 0);
}

void TMainWindow::ActionDecode()
{
	uint i, completed = 0;
	TFTNCoDec *Decoder = new TFTNCoDec();
	QByteArray *Array = new QByteArray();
	QString FileName;
	TMessageItem *It;

	TArea *Area = ((TAreaItem*)AreaList->selectedItem())->Area;

	for (i = 0; i < Area->count(); i++)
	{
		It = Area->at(i)->MessageItem;
		if (It != NULL)
			if (It->isMarked())
				Decoder->DecodeMessage(Area->at(i));
	}

	while (Decoder->MakeFile(Array, &FileName))
	{
		QFileDialog* fd = new QFileDialog(this);
		fd->setDir(Config->GetStr(QString::null, CONFIG_LASTOPENSAVE, QString::null));
		fd->setFilter(QObject::tr("All Files (*)"));
		fd->setCaption(QObject::tr("Select file..."));
		fd->setIcon(*Config->FindPixmap("icon_save.xpm"));
		fd->setMode(QFileDialog::AnyFile);
		fd->setInfoPreviewEnabled(true);
		if (!FileName.isEmpty())
			fd->setSelection(FileName);
		bool Retry = true;
		while (Retry)
		{
			Retry = false;
			if (fd->exec() == QDialog::Accepted)
			{
				QFileInfo fi(fd->selectedFile());
				if (!ValidateFileName(fi.fileName()))
					if (questionmessage(this, QObject::tr("File name contain invalid characters. Do You want set another file name?")))
					{
						Retry = true;
						continue;
					}
				Config->SetStr(QString::null, CONFIG_LASTOPENSAVE, fd->dir()->absPath());
				QFile UUE(fd->selectedFile());
				if (UUE.exists())
				{
					if (!questionmessage(this, QObject::tr("File already exists. Overwrite?")))
					{
						Retry = true;
						continue;
					}
				}
				if (FileOpenFunc(&UUE, IO_WriteOnly | IO_Truncate))
				{
					UUE.writeBlock(Array->data(), Array->size());
					FileCloseFunc(&UUE);
					completed++;
				} else
					errormessage(this, QObject::tr("Unable to save file."));
			}
		}
	}

	if (completed)
		statusBar()->message(QObject::tr("Succesfully decoded %1 files.").arg(completed), 1000);

	for (i = 0; i < Area->count(); i++)
	{
		It = Area->at(i)->MessageItem;
		if (It != NULL)
			if (It->isMarked())
				It->ToggleMarked();
	}

	delete Array;
	delete Decoder;
}

void TMainWindow::ActionWordWrap()
{
	TextEdit->setWrapPolicy(WordWrapAction->isOn() ? QTextEdit::AtWordOrDocumentBoundary : QTextEdit::AtWordBoundary);
}

void TMainWindow::ActionMessageProp()
{
	qDebug("TMainWindow::ActionMessageProp() Not implemented yet...");
}

void TMainWindow::ActionPreviousArea()
{
	AreaList->setSelected(AreaList->selectedItem()->itemAbove(), true);
}

void TMainWindow::ActionNextArea()
{
	AreaList->setSelected(AreaList->selectedItem()->itemBelow(), true);
}

void TMainWindow::ActionMarkAllAsRead()
{
	TArea *Area = ((TAreaItem*)AreaList->selectedItem())->Area;
	Area->MarkAllAsRead();
	AreaList->selectedItem()->repaint();
	MarkAllAsReadAction->setEnabled(Area->Unread > 0);
}

void TMainWindow::ActionUnsubscribe()
{
	TAreaSelect *SelectWnd = new TAreaSelect(this);
	for (uint i = 0; i < Areas->count(); i++)
	{
		TArea *Area = Areas->at(i);
		if (Area->Type == AREA_TYPE_NETMAIL)
			SelectWnd->AddArea((void*)Area);
	}
	if (SelectWnd->AreasCnt > 1)
	{
		if (SelectWnd->exec() == QDialog::Accepted)
			RunEditor(((TAreaSelectItem*)SelectWnd->SelectAreaList->selectedItem())->Area, NULL, MSG_OPERATION_UNSUBSCRIBE, (void*)((TAreaItem*)AreaList->selectedItem())->Area);
	} else if (SelectWnd->AreasCnt == 1)
		RunEditor(((TAreaSelectItem*)SelectWnd->SelectAreaList->firstChild())->Area, NULL, MSG_OPERATION_UNSUBSCRIBE, (void*)((TAreaItem*)AreaList->selectedItem())->Area);
	delete SelectWnd;
}

void TMainWindow::ActionAreaProp()
{
	if (AreaList->selectedItem())
	{
		TArea *Area = ((TAreaItem*)AreaList->selectedItem())->Area;

		TAreaProp *PropWnd = new TAreaProp(this);

		PropWnd->SetUp(Area);
		PropWnd->exec();

		delete PropWnd;
	}
}

#if !defined(QT_NO_PRINTER)
#	include <qpainter.h>
#	include <qprinter.h>
#	include <qsimplerichtext.h>
#	include <qpaintdevicemetrics.h>
#endif // QT_NO_PRINTER

void TMainWindow::ActionPrint()
{
#if !defined(QT_NO_PRINTER)
	QPrinter Printer(QPrinter::HighResolution);
	Printer.setFullPage(true);

	if (Printer.setup(this))
	{
		QPainter Painter;

		statusBar()->message(QObject::tr("Printing..."));

		if(!Painter.begin(&Printer))
		{
			statusBar()->message(QObject::tr("Printing aborted"), 1000);
			return;
        	}

		qApp->setOverrideCursor(QCursor(Qt::WaitCursor));
		qApp->eventLoop()->processEvents(QEventLoop::ExcludeUserInput);

		QPaintDeviceMetrics Metrics(Painter.device());
		int dpiy = Metrics.logicalDpiY();
		int margin = (int)((2 / 2.54) * dpiy);
		QRect view(margin, margin, Metrics.width() - 2 * margin, Metrics.height() - 2 * margin);

		QSimpleRichText RTF(TextEdit->text(), TextEdit->font(), TextEdit->context(), TextEdit->styleSheet(), TextEdit->mimeSourceFactory(), view.height(), UrlItem->color(), false);
		RTF.setWidth(&Painter, view.width());

		int page = 1;
		do {
			qApp->eventLoop()->processEvents(QEventLoop::ExcludeUserInput);
			RTF.draw(&Painter, margin, margin, view, colorGroup());
			view.moveBy(0, view.height());
			Painter.translate(0 , -view.height());
			Painter.drawText(view.right() - Painter.fontMetrics().width(QString::number(page)), view.bottom() + Painter.fontMetrics().ascent() + 5, QString::number(page));
			if ((view.top() - margin) >= RTF.height())
				break;
			Printer.newPage();
			page++;
		} while (true);

		Painter.end();

		qApp->eventLoop()->processEvents(QEventLoop::ExcludeUserInput);
		qApp->restoreOverrideCursor();

		statusBar()->message(QObject::tr("Printing completed."), 1000);
	};
#else // QT_NO_PRINTER
	informationmessage(this, QObject::tr("Printer support disabled by Qt-config."));
#endif // QT_NO_PRINTER
}

void TMainWindow::ActionNodelistBrowser()
{
	if (Config->IsDevelopMode())
	{
		qDebug("Develop Mode");
		TNodelistBrowser *NodelistBrowser = new TNodelistBrowser(this);
		if (!NodelistBrowser->TestLists())
			informationmessage(this, QObject::tr("No Nodelists in config."));
		else
		{
			NodelistBrowser->SetSelectMode(false);
			NodelistBrowser->exec();
		}
		delete NodelistBrowser;
	} else
		qDebug("TMainWindow::ActionNodelistBrowser() Not implemented yet...");
}

void TMainWindow::ActionAddressBook()
{
	TAddressBook *AddressBook = new TAddressBook(this);
	AddressBook->SetUp(false);
	if (AddressBook->exec() == QDialog::Accepted)
		Config->AddressBook->Save();
	else
		Config->AddressBook->Read();
	delete AddressBook;
}

void TMainWindow::ActionExtensions()
{
	qDebug("TMainWindow::ActionExtensions() Not implemented yet...");
}

void TMainWindow::ActionOptions()
{
	TOptions *Options = new TOptions(this);
	if (Options->exec() == QDialog::Accepted)
	{
		TArea *CurrentArea = (AreaList->selectedItem() != NULL) ? ((TAreaItem*)AreaList->selectedItem())->Area : NULL;
		Areas->Close();
		Config->DoneFido();
		Config->InitFido();
		LoadSettings();
		if (CurrentArea != NULL)
		{
			Areas->Open(CurrentArea);
			ActionRedrawMessage();
		}
	}
	delete Options;
}

void TMainWindow::ActionAboutQt()
{
	qApp->aboutQt();
}

void TMainWindow::ActionHelp()
{
	HelpIndex();
}

void TMainWindow::ActionAbout()
{
	TAbout *About = new TAbout(this);
	About->exec();
	delete About;
}

void TMainWindow::ActionWhatsThis()
{
	QWhatsThis::enterWhatsThisMode();
}

void TMainWindow::ToolBarVisibilityChanged(bool)
{
	if (isShown())
		ViewToolBarAction->setOn(MainToolBar->isShown());
}

void TMainWindow::ActionViewToolBar()
{
	MainToolBar->setShown(ViewToolBarAction->isOn());
}

void TMainWindow::ActionViewStatusBar()
{
	statusBar()->setShown(ViewStatusBarAction->isOn());
}

void TMainWindow::ClearMessageView()
{
	Current = NULL;
	FNLabel->clear();
	FALabel->clear();
	TNLabel->clear();
	TALabel->clear();
	SLabel->clear();
	FLabel->clear();
	DLabel->clear();
	TextEdit->clear();
	DeleteAction->setEnabled(false);
	PreviousMessAction->setEnabled(false);
	NextMessAction->setEnabled(false);
	MarkMessAction->setEnabled(false);
}

void TMainWindow::ClearMessageList()
{
	ClearMessageView();
	MessageList->clear();
	NewAction->setEnabled(false);
	EditAction->setEnabled(false);
	ReplyAction->setEnabled(false);
	ReplyNetmailAction->setEnabled(false);
	ForwardAction->setEnabled(false);
	PrintAction->setEnabled(false);
	SaveAction->setEnabled(false);
	DecodeAction->setEnabled(false);
}

void TMainWindow::ActionRescan()
{
	qDebug("TMainWindow::ActionRescan() Not implemented yet...");
}

void TMainWindow::ActionRescanAll()
{
	uint i, sc = AreaList->sortColumn();

	statusBar()->message(QObject::tr("Rescan Areas..."));
	AreaList->setSortColumn(-1);
	ClearMessageList();
	AreaList->clear();
	Areas->clear();

	PreviousAreaAction->setEnabled(false);
	NextAreaAction->setEnabled(false);
	MarkAllAsReadAction->setEnabled(false);
	UnsubscribeAction->setEnabled(false);
	AreaPropAction->setEnabled(false);
	FindAction->setEnabled(false);

	AreaList->setUpdatesEnabled(false);
	for (i = 0; i < Config->FidoConfig->netMailAreaCount; i++)
		new TAreaItem(AreaList, Areas->Add(Config->FidoConfig->netMailAreas[i], AREA_TYPE_NETMAIL));
	new TAreaItem(AreaList, Areas->Add(Config->FidoConfig->dupeArea, AREA_TYPE_DUPE));
	new TAreaItem(AreaList, Areas->Add(Config->FidoConfig->badArea, AREA_TYPE_BAD));
	for (i = 0; i < Config->FidoConfig->localAreaCount; i++)
		new TAreaItem(AreaList, Areas->Add(Config->FidoConfig->localAreas[i], AREA_TYPE_LOCAL));
	for (i = 0; i < Config->FidoConfig->echoAreaCount; i++)
		if (Config->FidoConfig->echoAreas[i].msgbType != MSGTYPE_PASSTHROUGH)
			new TAreaItem(AreaList, Areas->Add(Config->FidoConfig->echoAreas[i], AREA_TYPE_ECHOMAIL));

	FindAction->setEnabled(Areas->count() > 0);

	AreaList->setUpdatesEnabled(true);
	AreaList->setSortColumn(sc);
	qApp->processEvents();

	i = Areas->Find(LastAreaName);
	AreaList->setSelected(AreaList->findItem(QString::number((i != 0) ? i : 1), 0), true);
	statusBar()->message(QObject::tr("Rescan Done."), 1000);
}

void TMainWindow::ActionRedrawMessage()
{
	Current = NULL;
	MessageChanged(MessageList->selectedItem());
}

void TMainWindow::FindCallBack(TFindItem *Item)
{
	bool found = false;
	QListViewItemIterator It;

	It = QListViewItemIterator(AreaList);
	while (It.current())
	{
		if (((TAreaItem*)It.current())->Area == Item->Area)
		{
			AreaList->setSelected(It.current(), true);
			found = true;
			break;
		}
		++It;
	}

	if (found)
	{
		It = QListViewItemIterator(MessageList);
		while (It.current())
		{
			if (((TMessageItem*)It.current())->Message == Item->Message)
			{
				MessageList->setSelected(It.current(), true);
				break;
			}
			++It;
		}
	}
}

void TMainWindow::AreaChanged(QListViewItem *Item)
{
	if (Item == NULL)
	{
		ClearMessageList();
		return;
	}

	TArea *Area = ((TAreaItem*)Item)->Area;

	if (Current != NULL)
		if (Current->Area == Area)
			return;

	MessageList->setUpdatesEnabled(false);
	ClearMessageList();

	AreaList->ensureItemVisible(Item);

	NewAction->setEnabled((Area->Type == AREA_TYPE_NETMAIL) || (Area->Type == AREA_TYPE_ECHOMAIL));

	PreviousAreaAction->setEnabled(Item != AreaList->firstChild());
	NextAreaAction->setEnabled(Item != AreaList->lastItem());
	UnsubscribeAction->setEnabled(Area->Type == AREA_TYPE_ECHOMAIL);

	if (Areas->Open(Area))
	{
		AreaPropAction->setEnabled(true);
		LastAreaName = Area->Name;
		for (uint i = 0; i < Area->count(); i++)
			new TMessageItem(MessageList, (TAreaItem*)Item, Area->at(i));
		uint lr = Area->GetLastRead();
		if ((lr <= Area->count()) && (lr > 0))
		{
			MessageList->setSelected(Area->at(lr - 1)->MessageItem, true);
		} else {
			if (!Area->count())
				Area->SetLastRead(0);
			MessageList->setSelected(MessageList->firstChild(), true);
		}

		MarkAllAsReadAction->setEnabled(Area->Unread > 0);
	}

	MessageList->setUpdatesEnabled(true);
	MessageList->triggerUpdate();
}

void TMainWindow::ParseColorLine(QString *Line, uint Start)
{
	//TODO: Parser Need Full Rewrite !!!

	bool InScope = false, hstyle = Config->GetBool(QString::null, CONFIG_VIEWSTYLE, true);
	byte StartTag = 0, EndTag = 0;
	int j;
	uint i = Start, StartTagPos = 0, EndTagPos = 0;

//qDebug("String Start=%i =%s", Start, Line->ascii());

	if (!ViewHighlightAction->isOn()) return;

	if (Line->find("<a&nbsp;href=") < 0)
	{
		QRegExp rx(REGEXP_URL);
		j = rx.search(*Line, Start);
		if (j > -1)
		{
			Line->insert(j + rx.matchedLength(), "</utag></a>");
			Line->insert(j, "<a&nbsp;href=\"" + rx.cap().stripWhiteSpace() + "\"><utag>");
		}
	}

/* This code is work fine. Later I remake this function as below.
QRegExp rx("(^|\\B)[*].+[*]($|\\B)");
j = rx.search(*Line, Start);
if (j > -1)
{
	Line->remove(j + rx.matchedLength() - 1, 1);
	Line->insert(j + rx.matchedLength() - 1, "</utag>");
	Line->remove(j, 1);
	Line->insert(j, "<utag>");
}
return;
*/

	while (i < Line->length())
	{
		QChar CurChar = Line->at(i);
		if (CurChar == QChar('<'))
		{
			j = Line->find('>', i + 1);
			if (j > -1)
			{
				i += j + 1;
				j = Line->find('<', i);
				if (j > -1)
				{
					i += j + 1;
					j = Line->find('>', i);
					if (j > -1)
						i += j + 1;
				}
				continue;
			}
		}
		if (hstyle)
		{
			/* GoldEd Style Highlight */
			if (CurChar == QChar('*'))
			{
				if (!InScope)
				{
//					if ((i == Start) || ((i > Start) && QString("*/_#").find(Line->at(i - 1)) > -1))
//					{
						InScope = true;
						StartTag |= 1;
						EndTag = 0;
						EndTagPos = 0;
						if (!StartTagPos) StartTagPos = i;
//					}
				} else {
					EndTag |= 1;
					if (!EndTagPos) EndTagPos = i;
				}
			} else if (CurChar == QChar('/'))
			{
				if (!InScope)
				{
//					if ((i == Start) || ((i > Start) && QString("*/_#").find(Line->at(i - 1)) > -1))
//					{
						InScope = true;
						StartTag |= 2;
						EndTag = 0;
						EndTagPos = 0;
						if (!StartTagPos) StartTagPos = i;
//					}
				} else {
					EndTag |= 2;
					if (!EndTagPos) EndTagPos = i;
				}
			} else if (CurChar == QChar('_'))
			{
				if (!InScope)
				{
//					if ((i == Start) || ((i > Start) && QString("*/_#").find(Line->at(i - 1)) > -1))
//					{
						InScope = true;
						StartTag |= 4;
						EndTag = 0;
						EndTagPos = 0;
						if (!StartTagPos) StartTagPos = i;
//					}
				} else {
					EndTag |= 4;
					if (!EndTagPos) EndTagPos = i;
				}
			} else if (CurChar == QChar('#'))
			{
				if (!InScope)
				{
//					if ((i == Start) || ((i > Start) && QString("*/_#").find(Line->at(i - 1)) > -1))
//					{
						InScope = true;
						StartTag |= 8;
						EndTag = 0;
						EndTagPos = 0;
						if (!StartTagPos) StartTagPos = i;
//					}
				} else {
					EndTag |= 8;
					if (!EndTagPos) EndTagPos = i;
				}
			} else {
				if (EndTagPos)
				{
					if (((EndTagPos - StartTagPos) > 1) && ((i == (Line->length() - 1)) || CurChar.isSpace() || CurChar.isPunct()))
					{
						break;
					} else {
						InScope = false;
						i = StartTagPos + 1;
						StartTagPos = 0;
						EndTagPos = 0;
						StartTag = 0;
						continue;
					}
				}
			}
		} else {
			/* FIPS Style Highlight */
			if (CurChar == QChar('*'))
			{
				if (!InScope)
				{
					InScope = true;
					StartTag |= 1;
					EndTag = 0;
					EndTagPos = 0;
					if (!StartTagPos) StartTagPos = i;
				} else {
					EndTag |= 1;
					if (!EndTagPos) EndTagPos = i;
				}
			} else if (CurChar == QChar('_'))
			{
				if (!InScope)
				{
					InScope = true;
					StartTag |= 2;
					EndTag = 0;
					EndTagPos = 0;
					if (!StartTagPos) StartTagPos = i;
				} else {
					EndTag |= 2;
					if (!EndTagPos) EndTagPos = i;
				}
			//
			//
			//
			} else {
				if (EndTagPos)
				{
					if (((EndTagPos - StartTagPos) > 1) && ((i == (Line->length() - 1)) || CurChar.isSpace() || CurChar.isPunct()))
					{
						break;
					} else {
						InScope = false;
						i = StartTagPos + 1;
						StartTagPos = 0;
						EndTagPos = 0;
						StartTag = 0;
						continue;
					}
				}
			}
		}
		i++;
	}
//qDebug("Finally StartTagPos=%i", StartTagPos);
//qDebug("Finally EndTagPos=%i", EndTagPos);
	StartTag &= EndTag;
	if (InScope && (EndTagPos > StartTagPos) && StartTag)
	{
		i = 0;

		if (StartTag & 1) i++;
		if (StartTag & 2) i++;
		if (StartTag & 4) i++;
		if (StartTag & 8) i++;
		// hstyle ?
		if (EndTagPos > (StartTagPos + i))
		{
			Line->remove(EndTagPos, i);
			Line->insert(EndTagPos, QString("</gtag%1>").arg(StartTag));
			Line->remove(StartTagPos, i);
			Line->insert(StartTagPos, QString("<gtag%1>").arg(StartTag));
			EndTagPos += QString("<gtag%1>").arg(StartTag).length() * 2 + 1 + 1 - i * 2;
		} else
			EndTagPos = StartTagPos + 1;
		ParseColorLine(Line, EndTagPos);
	} else if (StartTagPos && (StartTagPos < Line->length()))
		ParseColorLine(Line, StartTagPos + 1);
}

void TMainWindow::MessageChanged(QListViewItem *Item)
{
	char *TextBuffer, *CtrlBuffer, *CtrlFixed;
	//QString chrs;

	if (Item == NULL)
	{
		ClearMessageView();
		return;
	}

	if (Current != NULL)
		if (Current == ((TMessageItem*)Item)->Message)
			return;

	ClearMessageView();

	MessageList->ensureItemVisible(Item);

	PreviousMessAction->setEnabled(Item->itemAbove() != NULL);
	NextMessAction->setEnabled(Item->itemBelow() != NULL);

	Current = ((TMessageItem*)Item)->Message;
	if (Current == NULL)
		return;

	if (Current->ReadMessage())
	{
		EditAction->setEnabled(((Current->Area->Type == AREA_TYPE_NETMAIL) || (Current->Area->Type == AREA_TYPE_ECHOMAIL) || (strcompare(Current->Area->Name, Config->GetDraftArea()))) && Current->isFlagsSet(MSGLOCAL) && !Current->isFlagsSet(MSGSENT | MSGSCANNED | MSGCPT));

		ReplyAction->setEnabled((Current->Area->Type == AREA_TYPE_NETMAIL) || (Current->Area->Type == AREA_TYPE_ECHOMAIL));
		ReplyNetmailAction->setEnabled(Current->Area->Type == AREA_TYPE_ECHOMAIL);
		ForwardAction->setEnabled(!strcompare(Current->Area->Name, Config->GetDraftArea()));
		DeleteAction->setEnabled(true);
		PrintAction->setEnabled(true);
		SaveAction->setEnabled(true);
		MarkMessAction->setEnabled(true);

		//TODO: Find CHRS here...
		//chrs = (char*)GetCtrlToken(Message->CtrlBuffer, (byte *)"CHRS: "));

		FNLabel->setText(Config->toUTF((char*)Current->MsgInfo.from));

		FALabel->setText(addr2str1(Current->MsgInfo.orig, Current->CtrlBuffer));

		TNLabel->setText(Config->toUTF((char*)Current->MsgInfo.to));
		if (Current->Area->Type == AREA_TYPE_NETMAIL)
			TALabel->setText(addr2str1(Current->MsgInfo.dest));
		SLabel->setText(Config->toUTF((char*)Current->MsgInfo.subj));
		DLabel->setText(QDateTime(QDate(Current->MsgInfo.date_written.date.yr + 1980, Current->MsgInfo.date_written.date.mo, Current->MsgInfo.date_written.date.da), QTime(Current->MsgInfo.date_written.time.hh, Current->MsgInfo.date_written.time.mm, Current->MsgInfo.date_written.time.ss)).toString("hh:mm:ss dd MMM yyyy"));

		TextBuffer = new char[Current->TextLen + 1];
		CtrlBuffer = new char[Current->CtrlLen + 1];

		qstrncpy(TextBuffer, (char*)Current->TextBuffer, Current->TextLen);
		qstrncpy(CtrlBuffer, (char*)Current->CtrlBuffer, Current->CtrlLen);
		TextBuffer[Current->TextLen] = '\0';
		CtrlBuffer[Current->CtrlLen] = '\0';

		char *chfl = (char*)GetCtrlToken(Current->CtrlBuffer, (byte *)"FLAGS");
		FLabel->setText(flags2str(Current->MsgInfo.attr, chfl));
		if (chfl)
			nfree(chfl);

		fix_crlf(TextBuffer);
		CtrlFixed = (char*)CvtCtrlToKludge((byte*)CtrlBuffer);
		fix_crlf(CtrlFixed);

		//TODO: GetCharset...

		QString Kludges = ViewKludgesAction->isOn() ? TextEdit->styleSheet()->escape(Config->toUTF(CtrlFixed)) : QString::null;

		Q_ASSERT(!TextEdit->styleSheet()->mightBeRichText(TextBuffer));

		QString Buffer = TextEdit->styleSheet()->escape(Config->toUTF(TextBuffer));
		QStringList BufferList = QStringList::split("\n", Buffer, true);
		Buffer = QString::null;
		int i, j, s = 0, ListCnt = BufferList.count();

		for (i = BufferList.count() - 1; i >= 0; i--)
		{
			if (BufferList[i].startsWith("SEEN-BY: ") || BufferList[i].startsWith("\001PATH: ") || BufferList[i].startsWith("\001Via "))
			{
				if (ViewHighlightAction->isOn()) BufferList[i].prepend("<ktag>").append("</ktag>");
				if (!ViewKludgesAction->isOn()) ListCnt = i;
			} else if (BufferList[i].startsWith(" * Origin: "))
			{
				if (ViewHighlightAction->isOn())
				{
					BufferList[i].prepend("<otag>").append("</otag>");
					s++;
				}
			} else if (BufferList[i].startsWith("... "))
			{
				if (ViewHighlightAction->isOn()) BufferList[i].prepend("<rtag>").append("</rtag>");
			} else if (BufferList[i].startsWith("--- "))
			{
				if (ViewHighlightAction->isOn()) BufferList[i].prepend("<ltag>").append("</ltag>");
			} else if (!BufferList[i].isEmpty()) break;
		}

		for (i = 0; i < ListCnt; i++)
		{
			if (i < (ListCnt - s))
			{
				j = BufferList[i].find("&gt;");
				if ((j > -1) && (j < 5))
					BufferList[i].prepend("<qtag>").append("</qtag>");
				ParseColorLine(&BufferList[i], 0);
			}
			Buffer += ((Buffer == QString::null) ? QString::null : "<br>") + BufferList[i];
		}

		TextEdit->setText(convert2qhtm(Buffer.prepend(ViewKludgesAction->isOn() ? Kludges.prepend(ViewHighlightAction->isOn() ? "<ktag>" : QString::null).append(ViewHighlightAction->isOn() ? "</ktag>" : QString::null) : QString::null)));

		MarkAllAsReadAction->setEnabled(((TMessageItem*)Item)->Message->Area->Unread > 0);

		((TMessageItem*)Item)->StartTimer();

		delete TextBuffer;
		delete CtrlBuffer;
		delete CtrlFixed;
	}
}

void TMainWindow::HelpIndex()
{
	if (HelpWindow == NULL)
		HelpWindow = new THelpWindow(this);
	if (HelpWindow->isShown())
		HelpWindow->hide();
	HelpWindow->show();
}

void TMainWindow::TextEditLinkClicked(const QString &Link)
{
	bool urldone = false;
	QString Tok, Cmd = Config->GetStr(QString::null, CONFIG_EXTBROWSER, QString::null);

	if (!Cmd.isEmpty())
	{
		QProcess proc(this);
		uint tc = tokencount(Cmd, " ");
		if (tc > 0)
		{
			for (uint i = 0; i < tc; i++)
			{
				Tok = gettoken(Cmd, i + 1, " ");
				if (Tok.find("%u") > -1)
				{
					Tok = Tok.replace("%u", Link);
					urldone = true;
				}
				proc.addArgument(Tok);
			}
			if (!urldone)
				proc.addArgument(Link);
			proc.setWorkingDirectory(QDir());
			if (!proc.start())
				statusBar()->message(QObject::tr("Error starting HTML browser."), 1000);
		}
	} else
		informationmessage(this, QObject::tr("External browser not set."));

	TextEdit->setSource(QString::null);
}
