/***************************************************************************
 *   Copyright (C) 2005 by Alexander Shiyan                                *
 *   shc@users.sourceforge.net                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

extern TConfig *Config;

void TMessAttr::init()
{
        setIcon(*Config->FindPixmap("icon_flag.xpm"));

	BtnOk->setIconSet(QIconSet(*Config->FindPixmap("icon_ok.xpm")));
	BtnCancel->setIconSet(QIconSet(*Config->FindPixmap("icon_cancel.xpm")));

	Config->GetPos(this);
	Allow = 0;
}

void TMessAttr::SetCheckBox(QCheckBox *box, QString Name, QString Hint, bool _Allow, bool State)
{
	box->setText(Name);
	box->setEnabled(_Allow);
	box->setChecked(State);
	QToolTip::add(box, Hint);
}

void TMessAttr::closeEvent(QCloseEvent *e)
{
	Config->SetPos(this);
	e->accept();
}

void TMessAttr::SetUp(uint _Allow, uint State)
{
	Allow = _Allow;
	SetCheckBox(Flag1, "Private", flag2desc(MSGPRIVATE), Allow & MSGPRIVATE, State & MSGPRIVATE);
	SetCheckBox(Flag2, "Crash", flag2desc(MSGCRASH), Allow & MSGCRASH, State & MSGCRASH);
	SetCheckBox(Flag3, "Sent", flag2desc(MSGSENT), Allow & MSGSENT, State & MSGSENT);
	SetCheckBox(Flag4, "File", flag2desc(MSGFILE), Allow & MSGFILE, State & MSGFILE);
	SetCheckBox(Flag5, "Forward", flag2desc(MSGFWD), Allow & MSGFWD, State & MSGFWD);
	SetCheckBox(Flag6, "Orphan", flag2desc(MSGORPHAN), Allow & MSGORPHAN, State & MSGORPHAN);
	SetCheckBox(Flag7, "Kill", flag2desc(MSGKILL), Allow & MSGKILL, State & MSGKILL);
	SetCheckBox(Flag8, "Local", flag2desc(MSGLOCAL), Allow & MSGLOCAL, State & MSGLOCAL);
	SetCheckBox(Flag9, "Hold", flag2desc(MSGHOLD), Allow & MSGHOLD, State & MSGHOLD);
	SetCheckBox(Flag10, "Direct", flag2desc(MSGXX2), Allow & MSGXX2, State & MSGXX2);
	SetCheckBox(Flag11, "File Request", flag2desc(MSGFRQ), Allow & MSGFRQ, State & MSGFRQ);
	SetCheckBox(Flag12, "Receipt Request", flag2desc(MSGRRQ), Allow & MSGRRQ, State & MSGRRQ);
	SetCheckBox(Flag13, "Is Return Receipt", flag2desc(MSGCPT), Allow & MSGCPT, State & MSGCPT);
	SetCheckBox(Flag14, "Audit Request", flag2desc(MSGARQ), Allow & MSGARQ, State & MSGARQ);
	SetCheckBox(Flag15, "Update Request", flag2desc(MSGURQ), Allow & MSGURQ, State & MSGURQ);
	SetCheckBox(Flag16, "Immediate", flag2desc(MSGIMM), Allow & MSGIMM, State & MSGIMM);
}

uint TMessAttr::GetState()
{
	uint tmp = 0;

	tmp |= Flag1->isChecked() ? MSGPRIVATE : 0;
	tmp |= Flag2->isChecked() ? MSGCRASH : 0;
	tmp |= Flag3->isChecked() ? MSGSENT : 0;
	tmp |= Flag4->isChecked() ? MSGFILE : 0;
	tmp |= Flag5->isChecked() ? MSGFWD : 0;
	tmp |= Flag6->isChecked() ? MSGORPHAN : 0;
	tmp |= Flag7->isChecked() ? MSGKILL : 0;
	tmp |= Flag8->isChecked() ? MSGLOCAL : 0;
	tmp |= Flag9->isChecked() ? MSGHOLD : 0;
	tmp |= Flag10->isChecked() ? MSGXX2 : 0;
	tmp |= Flag11->isChecked() ? MSGFRQ : 0;
	tmp |= Flag12->isChecked() ? MSGRRQ : 0;
	tmp |= Flag13->isChecked() ? MSGCPT : 0;
	tmp |= Flag14->isChecked() ? MSGARQ : 0;
	tmp |= Flag15->isChecked() ? MSGURQ : 0;
	tmp |= Flag16->isChecked() ? MSGIMM : 0;

	return (tmp & Allow);
}
