/***************************************************************************
 *   Copyright (C) 2005 by Alexander Shiyan                                *
 *   shc@users.sourceforge.net                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

extern TConfig *Config;

void TNodelistBrowser::init()
{
	FirstTimeInit = false;

	setIcon(*Config->FindPixmap("icon_browser.xpm"));

	BtnOk->setIconSet(QIconSet(*Config->FindPixmap("icon_ok.xpm")));
	BtnCancel->setIconSet(QIconSet(*Config->FindPixmap("icon_cancel.xpm")));

	BtnFindAddr->setIconSet(QIconSet(*Config->FindPixmap("icon_find.xpm")));
	BtnFindName->setIconSet(QIconSet(*Config->FindPixmap("icon_find.xpm")));

	Config->GetPos(this);
	Nodes = new TNodes();
	NodeTree->setSortColumn(-1);
	//NodeTree->setSorting(0, false);

	SelectMode = false;
	Selected = NULL;
}

void TNodelistBrowser::destroy()
{
	delete Nodes;
}

void TNodelistBrowser::showEvent(QShowEvent *)
{
	if (FirstTimeInit)
		return;

	NodeTree->setUpdatesEnabled(false);
	Nodes->Compile();
	Nodes->AssignListView(NodeTree);
	NodeTree->setUpdatesEnabled(true);
	NodeTree->update();
}

void TNodelistBrowser::closeEvent(QCloseEvent *e)
{
	Config->SetPos(this);
	Config->SetSize(this);
	e->accept();
}

void TNodelistBrowser::SetSelectMode(bool Value)
{
	SelectMode = Value;
}

bool TNodelistBrowser::TestLists()
{
	return (Nodes->TestCount() > 0);
}

void TNodelistBrowser::TreeSelectionChanged(QListViewItem *It)
{
	NameEdit->setText(QString::null);
	SysOpEdit->setText(QString::null);
	LocationEdit->setText(QString::null);
	PhoneEdit->setText(QString::null);
	SpeedEdit->setText(QString::null);
	FlagsEdit->setText(QString::null);
	BtnOk->setEnabled(false);

	Selected = NULL;

	if (It != NULL)
	{
		TNodeItem *Item = (TNodeItem*)It;
		NameEdit->setText(Item->Name);
		SysOpEdit->setText(Item->SysOp);
		LocationEdit->setText(Item->Town);
		PhoneEdit->setText(Item->Phone);
		SpeedEdit->setText(Item->Speed);
		FlagsEdit->setText(Item->Flags);

		Selected = Item;

		BtnOk->setEnabled(SelectMode);
	}
}

void TNodelistBrowser::TreeDoubleClicked(QListViewItem *It)
{
	if ((It != NULL) && BtnOk->isEnabled())
		accept();
}
