/***************************************************************************
 *   Copyright (C) 2005 by Alexander Shiyan                                *
 *   shc@users.sourceforge.net                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _UTILS_H_
#define _UTILS_H_

#include <qfile.h>
#include <qtimer.h>
#include <qwidget.h>
#include <qprocess.h>
#include <qmessagebox.h>
#include <qapplication.h>

#include "config.h"
#include "funchider.h"

#include "tarea.h"
#include "tconfig.h"
#include "tmessage.h"
#include "tfidoconfig.h"

#define CODEPAGES_COUNT		4

#if defined(Q_WS_WIN)
#	define random()	rand()
#endif

extern QString QFECodePages[CODEPAGES_COUNT][3];

void errormessage(QWidget*, QString);
void informationmessage(QWidget*, QString);
bool questionmessage(QWidget*, QString);

QString addr2str1(NETADDR, byte* = NULL);
QString addr2str2(hs_addr);

void addr2addr(NETADDR*, hs_addr*);

QString flags2str(dword, char* = NULL);
QString flag2desc(dword);

void fix_crlf(char*);
void unfix_crlf(char*);

QString convert2qhtm(QString);
QString convert2qhtm_ext(QString);

bool testexists(QString);

bool strcompare(QString, QString);

int tokencount(QString, QString = " ");
QString gettoken(QString, int, QString = " ");

void AppendArray(QByteArray*, QByteArray*);

bool ParseCommand(QObject*, QString*);

bool ValidateFileName(QString);

int CompareVersions(QString, QString);

QString GetMessageMsgId();

uint RandomNumber(uint, uint);

void ExpandMacros(TArea*, TMessage*, QString*, QString);
void ExpandMacros2(QWidget*, QString*);

#endif // _UTILS_H_
